datablock ParticleData(DirtShootParticle)
{
	dragCoefficient = 0.75;
	windCoefficient = 0.2;
	gravityCoefficient = 0.01;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 200;
	lifetimeVarianceMS = 25;
	spinSpeed = 0;
	spinRandomMin = -900;
	spinRandomMax = 900;
	useInvAlpha = true;
	textureName = "base/data/particles/cloud";

	colors[0] = "0.6 0.35 0 1";
	colors[1] = "0.5 0.25 0 1";
	colors[2] = "0.25 0.125 0 0";
	sizes[0] = 0.55;
	sizes[1] = 0.63;
	sizes[2] = 0.4;
	times[0] = 0;
	times[1] = 0.5;
	times[2] = 1;
};

datablock ParticleEmitterData(DirtShootEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 5;
	ejectionVelocity = 0.75;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	particles = DirtShootParticle;
	uiName = "Dirt Shot";
};

datablock ProjectileData(TrenchDirtProjectile)
{
	shapeFile = "base/data/shapes/empty.dts";
	directDamage = 0;
	directDamageType = "";
	radiusDamageType = "";

	brickExplosionRadius = 0;
	brickExplosionImpact = false;
	brickExplosionForce = 0;
	brickExplosionMaxVolume = 0;
	brickExplosionMaxVolumeFloating = 0;

	impactImpulse = 0;
	verticalImpulse = 0;
	explosion = "";
	particleEmitter = DirtShootEmitter;

	collideWithPlayers = false;

	muzzleVelocity = 35;
	velInheritFactor = 1;

	armingDelay = 0;
	lifetime = 1500;
	fadeDelay = 0;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = true;
	gravityMod = 0;

	hasLight = false;
	lightRadius = 2;
	lightColor = "1 0.5 0";

	uiName = "Trench Dirt";
};

datablock ProjectileData(TrenchDirtGravProjectile : TrenchDirtProjectile)
{
	lifetime = 4500;
	gravityMod = 1;

	uiName = "Trench Dirt Gravity";
};

datablock ProjectileData(TrenchClusterProjectile : TrenchDirtProjectile)
{
	shapeFile = "base/data/shapes/empty.dts";
	directDamage = 45;

	impactImpulse = 15;
	verticalImpulse = 5;

	muzzleVelocity = 15;
	velInheritFactor = 1;

	lifetime = 4500;
	gravityMod = 1;

	uiName = "Trench Cluster";
};

datablock itemData(TrenchShovelItem)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	uiName = "Trench Shovel";
	doColorShift = true;
	colorShiftColor = "0.475 0.555 0.475 1.000";
	
	image = "TrenchShovelImage";
	canDrop = true;
};
datablock itemData(TrenchDirtItem)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	uiName = "Trench Dirt";
	doColorShift = true;
	colorShiftColor = "0.545098 0.270588 0.074509 1";
	
	image = "TrenchDirtImage";
	canDrop = true;
};
datablock itemData(TrenchClusterItem)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	uiName = "Trench Cluster";
	doColorShift = true;
	colorShiftColor = "0.545098 0.270588 0.074509 1";
	
	image = "TrenchClusterImage";
	canDrop = true;
};
datablock itemData(TrenchClusterBombItem)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	uiName = "Trench Cluster Bomb";
	doColorShift = true;
	colorShiftColor = "0.545098 0.270588 0.074509 1";
	
	image = "TrenchClusterBombImage";
	canDrop = true;
};

datablock ShapeBaseImageData(TrenchShovelImage)
{
	projectile = "";
	shapeFile = "base/data/shapes/brickweapon.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	correctMuzzleVector = false;
	className = "WeaponImage";
	item = TrenchShovelItem;
	ammo = " ";
	melee = true;
	doRetraction = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = "0.475 0.555 0.475 1.000";

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.5;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "PreFire";
	stateAllowImageChange[1]       = true;

	stateName[2]                   = "PreFire";
	stateScript[2]                 = "onPreFire";
	stateAllowImageChange[2]       = false;
	stateTimeoutValue[2]           = 0.1;
	stateTransitionOnTimeout[2]    = "Fire";

	stateName[3]                   = "Fire";
	stateTransitionOnTimeout[3]    = "CheckFire";
	stateTimeoutValue[3]           = 0.3;
	stateFire[3]                   = true;
	stateAllowImageChange[3]       = false;
	stateScript[3]                 = "onFire";
	stateWaitForTimeout[3]         = true;

	stateName[4]                   = "CheckFire";
	stateTransitionOnTriggerUp[4]  = "StopFire";
	stateTransitionOnTriggerDown[4]= "PreFire";

	stateName[5]                   = "StopFire";
	stateTransitionOnTimeout[5]    = "Ready";
	stateTimeoutValue[5]           = 0.2;
	stateAllowImageChange[5]       = false;
	stateWaitForTimeout[5]         = true;
};
datablock ShapeBaseImageData(TrenchDirtImage)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";
	item = TrenchDirtItem;
	ammo = " ";

	projectile = TrenchDirtProjectile;
	projectileType = Projectile;

	melee = false;
	doRetraction = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = "0.545098 0.270588 0.074509 1";

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.5;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "PreFire";
	stateAllowImageChange[1]       = true;

	stateName[2]                   = "PreFire";
	stateScript[2]                 = "onPreFire";
	stateAllowImageChange[2]       = false;
	stateTimeoutValue[2]           = 0.1;
	stateTransitionOnTimeout[2]    = "Fire";

	stateName[3]                   = "Fire";
	stateTransitionOnTimeout[3]    = "CheckFire";
	stateTimeoutValue[3]           = 0.3;
	stateFire[3]                   = true;
	stateAllowImageChange[3]       = false;
	stateScript[3]                 = "onFire";
	stateWaitForTimeout[3]         = true;

	stateName[4]                   = "CheckFire";
	stateTransitionOnTriggerUp[4]  = "StopFire";
	stateTransitionOnTriggerDown[4]= "PreFire";

	stateName[5]                   = "StopFire";
	stateTransitionOnTimeout[5]    = "Ready";
	stateTimeoutValue[5]           = 0.2;
	stateAllowImageChange[5]       = false;
	stateWaitForTimeout[5]         = true;
};
datablock ShapeBaseImageData(TrenchClusterImage : TrenchDirtImage)
{
	item = TrenchClusterItem;
	projectile = TrenchClusterProjectile;

	doColorShift = true;
	colorShiftColor = "0.495098 0.220588 0.024509 1";
};
datablock ShapeBaseImageData(TrenchClusterBombImage)
{
	item = TrenchClusterBombItem;

	doColorShift = true;
	colorShiftColor = "0.495098 0.220588 0.024509 1";

	shapeFile = "base/data/shapes/brickweapon.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";
	ammo = " ";

	projectile = TrenchClusterProjectile;
	projectileType = Projectile;

	melee = false;
	doRetraction = false;
	armReady = true;

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Done";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Done";
	stateScript[6]			= "onDone";
};

datablock ShapeBaseImageData(AdminDirtImage : TrenchDirtImage)
{
	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.05;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";

	stateName[2]                   = "Fire";
	stateTimeoutValue[2]           = 0.04;
	stateTransitionOnTimeout[2]    = "Ready";
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
};
datablock ShapeBaseImageData(AdminShovelImage : TrenchShovelImage)
{
	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.05;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";

	stateName[2]                   = "Fire";
	stateTimeoutValue[2]           = 0.04;
	stateTransitionOnTimeout[2]    = "Ready";
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
};


function TrenchShovelImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
	%obj.schedule(200, playthread, 2, root);
}
function TrenchDirtImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
	%obj.schedule(200, playthread, 2, root);
}
function TrenchShovelImage::onFire(%this,%obj,%slot)
{
	TakeChunk(%obj.client,1);
}
function TrenchDirtImage::onFire(%this,%obj,%slot)
{
	if(TrenchDigSO.value["trenchDirtCount",%obj.client.getBLID()] > 0)
		Parent::onFire(%this,%obj,%slot);
	ShootChunk(%obj.client);
}
function AdminShovelImage::onFire(%this,%obj,%slot)
{
	TakeChunk(%obj.client,1);
}
function AdminDirtImage::onFire(%this,%obj,%slot)
{
	if(TrenchDigSO.value["trenchDirtCount",%obj.client.getBLID()] > 0)
		Parent::onFire(%this,%obj,%slot);
	ShootChunk(%obj.client);
}


function TrenchClusterBombImage::onCharge(%this,%obj,%slot)
{
	%obj.playThread(2, "spearReady");
	%obj.lastCBSlot = %obj.currTool;
}
function TrenchClusterBombImage::onAbortCharge(%this,%obj,%slot)
{
	%obj.playThread(2, "root");
}
function TrenchClusterBombImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, "spearThrow");
	Parent::onFire(%this,%obj,%slot);

	%currSlot = %obj.lastCBSlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}
function TrenchClusterBombImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}


function TrenchClusterProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getClassname() $= "fxDtsBrick")
	{
		if(%col.getDatablock().isTrenchDirt)
		{
			lilDebug("All clear on starting cluster bomb");

			%BG = %col.getGroup();
			if(%col.getDatablock().isTrenchCube)
			{
				%radius = 2;
			}
			else
			{
				%radius = 1;
			}
			lilDebug("%radius is "@%radius);
			initContainerRadiusSearch(%pos,%radius,$TypeMasks::fxBrickObjectType);
			%break = 0;
			while((%brick = containerSearchNext()) != 0)
			{
				lilDebug("%brick is "@%brick);

				if(!%brick.getDatablock().isTrenchLowest)
				{
					%brick.refill(%obj.client,0);
					%break = 1;
					lilDebug("%break is 1 because brick was broken down");
				}
				else
				{
					spewClusterDirt(%brick.getPosition(),%normal,%obj.client,%brick.getColorID(),%BG);

					%brick.delete();
					%count++;
				}
			}
			if(%break)
			{
				lilDebug("Called continueClusterBreakdown function");
				schedule(1,0,"continueClusterBreakdown",%radius,%pos,%obj.client,%count,%normal,%col.getGroup());
			}
			else
			{
				lilDebug("Final %count is "@%count);
			}
		}
	}
	else
	{
		return Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	}
	lilDebug("Collision function is done");
}
function trenchDirtGravProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getClassname() $= "fxDTSBrick")
	{
		if(%col.getDatablock().isTrenchDirt)
		{
			lilDebug("Gravity Dirt Projectile collided with dirt");
			if(%col.getDatablock().isTrenchCube)
			{
				lilDebug("The dirt is a cube");
				%DB = "brick2xCubeDirtData";
				%smallPos = findSmallBrick(%col,%pos,%DB);
				lilDebug("smallPos found is "@%smallPos);
				%Diff = vectorSub(%smallPos,%pos);
				%else = 1;
				switch$(%DBName)
				{
					case "brick2xCubeDirtData":
						if(getWord(%Diff,2) == 1)
						{
							%Add = vectorSub(%smallPos,"0 0 1");
							%else = 0;
						}
					case "brick4xCubeDirtData":
						if(getWord(%Diff,2) == 1)
						{
							%Add = vectorSub(%smallPos,"0 0 1");
							%else = 0;
						}
					case "brick8xCubeDirtData":
						if(getWord(%Diff,2) == 1)
						{
							%Add = vectorSub(%smallPos,"0 0 1");
							%else = 0;
						}
					case "brick16xCubeDirtData":
						if(getWord(%Diff,2) == 1)
						{
							%Add = vectorSub(%smallPos,"0 0 1");
							%else = 0;
						}
				}
				if(%else)
				{
					lilDebug("%else is "@%else);
					%Scale = vectorScale(%normal,1);
					%Add = vectorAdd(%smallPos,%Scale);
				}
			}
			else
			{
				%DB = "brick1x1DirtData";
				%smallPos = findSmallBrick(%col,%pos,%DB);
				%Diff = vectorSub(%smallPos,%pos);
				if(getWord(%Diff,2) $= "0.3" || getWord(%Diff,2) >= 0.29)
				{
					%Add = getWord(%smallPos,0) SPC getWord(%smallPos,1) SPC getWord(vectorSub(%smallPos,"0 0 0.6"),2);
				}
				else
				{
					%Scale = vectorScale(%normal,0.5);
					%Add = vectorAdd(%smallPos,%Scale);
				}
			}
			if(%obj.brickColorID $= "")
			{
				%colorID = %col.getColorID();
			}
			else
			{
				%colorID = %obj.brickColorID;
			}

			lilDebug("Calling placeDirt");
			
			placeDirt(%Add,%colorID,%DB,%obj.client,%col.getGroup());
		}
	}
}

function continueClusterBreakdown(%radius,%pos,%client,%count,%normal,%BG)
{
	lilDebug("continueClusterBreakdown called");

	initContainerRadiusSearch(%pos,%radius,$TypeMasks::fxBrickObjectType);
	while((%brick = containerSearchNext()) != 0)
	{
		lilDebug("%brick is "@%brick);

		if(!%brick.getDatablock().isTrenchLowest)
		{
			%brick.refill(%obj.client,0);
			%break = 1;
			lilDebug("%break is 1 because brick was broken down");
		}
		else
		{
			spewClusterDirt(%brick.getPosition(),%normal,%client,%brick.getColorID(),%BG);

			%brick.delete();
			%count++;
		}
	}
	if(%break)
	{
		lilDebug("Called continueClusterBreakdown function");
		schedule(1,0,"continueClusterBreakdown",%radius,%pos,%client,%count,%normal,%BG);
	}
	else
	{
		lilDebug("Final %count is "@%count);
	}
}

function spewClusterDirt(%pos,%normal,%client,%colorID,%BG)
{

	%projectile = TrenchDirtGravProjectile;
	%spread = 0.035;

	%vector = vectorScale(%normal,0.25);
	%velocity = VectorScale(%vector, %projectile.muzzleVelocity);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (BowImage.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %pos;
		sourceObject = %client.player;
		client = %client;
		brickColorID = %colorID;
	};
	MissionCleanup.add(%p);
}