//blockByte v0.5
//Fast and simple database system by Zack "Zack0Wack0" Corr
//Free to use - just give credits where applicable
//(meaning I don't give a flying shit if you give me credits or not)
function blockByte::onAdd(%this)
{
	if(isFile(%this.dataBaseFile))
	{
		%this.importDatabase(%this.dataBaseFile,%this.dataBaseFormat);
	}
	if(%this.doAutoSave)
	{
		%this.autoSave();
	}
}
function blockByte::onRemove(%this)
{
	cancel(%this.autoSave);
}
function blockByte::autoSave(%this)
{
	cancel(%this.autoSave);
	if(%this.doAutoSave)
	{
		%this.exportDatabase(%this.dataBaseFile,%this.dataBaseFormat);
		%this.autoSave = %this.schedule(%this.autoSaveInterval < 60000 ? 60000 : %this.autoSaveInterval,"autoSave");
	}
}
function blockByte::addValue(%this,%value,%default)
{
	if(%this.valueExists(%value))
	{
		return 0;
	}
	if(%this.valueList $= "")
	{
		%this.valueList = %value;
	}
	else
	{
		%this.valueList = %this.valueList TAB %value;
	}
	%this.valueDefault[%value] = %default;
	return 1;
}
function blockByte::valueExists(%this,%value)
{
	for(%i=0;%i<getFieldCount(%this.valueList);%i++)
	{
		if(getField(%this.valueList,%i) $= %value)
		{
			return 1;
		}
	}
	return 0;
}
function blockByte::removeValue(%this,%value)
{
	if(!%this.valueExists(%value))
	{
		return 0;
	}
	for(%i=0;%i<getFieldCount(%this.valueList);%i++)
	{
		if(getField(%this.valueList,%i) $= %value)
		{
			if(%i $= 0)
			{
				%this.valueList = getFields(%this.valueList,1,getFieldCount(%this.valueList));
			}
			else if(%i $= getFieldCount(%this.valueList)-1)
			{
				%this.valueList = getFields(%this.valueList,0,%i-1);
			}
			else
			{
				%this.valueList = getFields(%this.valueList,0,%i-1) TAB getFields(%this.valueList,%i+1,getFieldCount(%this.valueList));
			}
			return 1;
		}
	}
	return 0;
}
function blockByte::addKey(%this,%key)
{
	if(%this.keyExists(%key))
	{
		return 0;
	}
	if(%this.keyList $= "")
	{
		%this.keyList = %key;
	}
	else
	{
		%this.keyList = %this.keyList TAB %key;
	}
	for(%i=0;%i<getFieldCount(%this.valueList);%i++)
	{
		%this.value[%key,getField(%this.valueList,%i)] = %this.valueDefault[getField(%this.valueList,%i)];
	}
	return 1;
}
function blockByte::keyExists(%this,%key)
{
	for(%i=0;%i<getFieldCount(%this.keyList);%i++)
	{
		if(getField(%this.keyList,%i) $= %key)
		{
			return 1;
		}
	}
	return 0;
}
function blockByte::removeKey(%this,%key)
{
	if(!%this.keyExists(%key))
	{
		return 0;
	}
	for(%i=0;%i<getFieldCount(%this.keyList);%i++)
	{
		if(getField(%this.keyList,%i) $= %key)
		{
			if(%i $= 0)
			{
				%this.keyList = getFields(%this.keyList,1,getFieldCount(%this.keyList));
			}
			else if(%i $= getFieldCount(%this.keyList)-1)
			{
				%this.keyList = getFields(%this.keyList,0,%i-1);
			}
			else
			{
				%this.keyList = getFields(%this.keyList,0,%i-1) TAB getFields(%this.keyList,%i+1,getFieldCount(%this.keyList));
			}
			return 1;
		}
	}
	return 0;
}
function blockByte::resetKey(%this,%key)
{
	if(!%this.keyExists(%key))
	{
		return 0;
	}
	for(%i=0;%i<getFieldCount(%this.valueList);%i++)
	{
		%this.value[%key,getField(%this.valueList,%i)] = %this.valueDefault[getField(%this.valueList,%i)];
	}
	return 1;
}
function blockByte::resetDatabase(%this)
{
	for(%i=0;%i<getFieldCount(%this.keyList);%i++)
	{
		%key = getField(%this.keyList,%i);
		for(%i=0;%i<getFieldCount(%this.valueList);%i++)
		{
			%value = getField(%this.valueList,%i);
			%this.value[%key,%value] = "";
			%this.valueDefault[%value] = "";
		}
	}
	%this.keyList = "";
	%this.valueList = "";
	return 1;
}
function blockByte::importDatabase(%this,%path,%type)
{
	%file = new FileObject();
	if(!isFile(%path))
	{
		%file.delete();
		return 0;
	}
	%this.resetDatabase();
	%file.openForRead(%path);
	switch$(%type)
	{
		case "CSV":
			%line = strReplace(strReplace(strReplace(%file.readLine(),"'",""),"\"",""),"\,","\t");
			for(%i=1;%i<getFieldCount(%line);%i++)
			{
				%args = strReplace(getField(%line,%i),"=","\t");
				%this.addValue(getField(%args,0),getField(%args,1));
			}
			while(!%file.isEOF())
			{
				%line = strReplace(strReplace(strReplace(%file.readLine(),"'",""),"\"",""),"\,","\t");
				%key = getField(%line,0);
				for(%i=1;%i<getFieldCount(%line);%i++)
				{
					%value = getField(%this.valueList,%i-1);
					%this.value[%key,%value] = getField(%line,%i);
				}
			}
		default:
			while(!%file.isEOF())
			{
				%line = %file.readLine();
				%function = getSubStr(%line,0,1);
				%args = strReplace(getSubStr(%line,2,strLen(%line)-3),"\,","\t");
				switch$(%function)
				{
					case "V":
						for(%i=0;%i<getFieldCount(%args);%i++)
						{
							%arg = strReplace(getField(%args,%i),"=","\t");
							%value[%i+1] = getField(%arg,0);
							%this.addValue(getField(%arg,0),getField(%arg,1));
						}
					case "K":
						%key = getField(%args,0);
						%this.addKey(%key);
						for(%i=1;%i<getFieldCount(%args);%i++)
						{
							%this.value[%key,%value[%i]] = getField(%args,%i);
						}
				}
			}
	}
	%file.close();
	%file.delete();
	return 1;
}
function blockByte::exportDatabase(%this,%path,%type)
{
	%file = new FileObject();
	if(!isWriteableFileName(%path) || %this.valueList $= "" || %this.keyList $= "")
	{
		%file.delete();
		return 0;
	}
	%file.openForWrite(%path);
	switch$(%type)
	{
		case "CSV":
			%line = "key";
			for(%i=0;%i<getFieldCount(%this.valueList);%i++)
			{
				%value = getField(%this.valueList,%i);
				%line = %line @ "," @ %value @ "=" @ %this.valueDefault[%value];
			}
			%file.writeLine(%line);
			for(%i=0;%i<getFieldCount(%this.keyList);%i++)
			{
				%key = getField(%this.keyList,%i);
				%line = %key;
				for(%a=0;%a<getFieldCount(%this.valueList);%a++)
				{
					%value = getField(%this.valueList,%a);
					%line = %line @ "," @ %this.value[%key,%value];
				}
				%file.writeLine(%line);
			}
		case "XML":
			%file.writeLine("<?xml version=\"1.0\">\n<values>");
			for(%i=0;%i<getFieldCount(%this.valueList);%i++)
			{
				%value = getField(%this.valueList,%i);
				%file.writeLine("<value>\n<name>" @ %value @ "</name>\n<default>" @ %this.valueDefault[%value] @ "</default>\n</value>");
			}
			%file.writeLine("</values>\n<keys>");
			for(%i=0;%i<getFieldCount(%this.keyList);%i++)
			{
				%key = getField(%this.keyList,%i);
				%file.writeLine("<key>\n<name>" @ %key @ "</name>");
				for(%a=0;%a<getFieldCount(%this.valueList);%a++)
				{
					%value = getField(%this.valueList,%a);
					%file.writeLine("<field>" @ %this.value[%key,%value] @ "</field>");
				}
				%file.writeLine("</key>");
			}
			%file.writeLine("</keys>");
		case "SQL":
			%file.writeLine("CREATE TABLE IF NOT EXISTS `blockByte` (");
			%file.writeLine("  `key` varchar(1024) NOT NULL default '',");
			for(%i=0;%i<getFieldCount(%this.valueList);%i++)
			{
				%value = getField(%this.valueList,%i);
				if(%i == getFieldCount(%this.valueList) - 1)
				{
					%file.writeLine("  `" @ %value @ "` varchar(1024) NOT NULL default '" @ %this.valueDefault[%value] @ "'");
				}
				else
				{
					%file.writeLine("  `" @ %value @ "` varchar(1024) NOT NULL default '" @ %this.valueDefault[%value] @ "'\,");
				}
			}
			%file.writeLine(");");
			for(%i=0;%i<getFieldCount(%this.keyList);%i++)
			{
				%key = getField(%this.keyList,%i);
				%args = "(" @ %key;
				for(%a=0;%a<getFieldCount(%this.valueList);%a++)
				{
					%value = getField(%this.valueList,%i);
					if(%value !$= "")
					{
						if(%a == getFieldCount(%this.valueList) - 1)
						{
							%args = %args @ ", '" @ %value @ "')";
						}
						else
						{
							%args = %args @ ", '" @ %value @ "'";
						}
					}
				}
				%file.writeLine("INSERT INTO `blockByte` VALUES " @ %args @ ";");
			}
		default:
			%line = "V(";
			for(%i=0;%i<getFieldCount(%this.valueList);%i++)
			{
				%value = getField(%this.valueList,%i);
				if(%i == getFieldCount(%this.valueList) - 1)
				{
					%line = %line @ %value @ "=" @ %this.valueDefault[%value] @ ")";
				}
				else
				{
					%line = %line @ %value @ "=" @ %this.valueDefault[%value] @ "\,";
				}
			}
			%file.writeLine(%line);
			for(%i=0;%i<getFieldCount(%this.keyList);%i++)
			{
				%key = getField(%this.keyList,%i);
				%line = "K(" @ %key @ "\,";
				for(%a=0;%a<getFieldCount(%this.valueList);%a++)
				{
					%value = getField(%this.valueList,%a);
					if(%value !$= "")
					{
						if(%a == getFieldCount(%this.valueList) - 1)
						{
							%line = %line @ %this.value[%key,%value] @ ")";
						}
						else
						{
							%line = %line @ %this.value[%key,%value] @ "\,";
						}
					}
				}
				%file.writeLine(%line);
			}
	}
	%file.close();
	%file.delete();
	return 1;
}